=== debian/changelog ===
spring (88.0+dfsg1-1.1ubuntu1) quantal; urgency=low

  * Fix glShaderSource stub signature to match that in <GL/glext.h>.

 -- Colin Watson <cjwatson@ubuntu.com>  Sun, 09 Sep 2012 23:58:23 +0100

spring (88.0+dfsg1-1.1build1) quantal; urgency=low

  * Rebuild for libglew1.8.

 -- Colin Watson <cjwatson@ubuntu.com>  Sun, 09 Sep 2012 22:45:12 +0100

spring (88.0+dfsg1-1.1) unstable; urgency=low

  * Non maintainer upload
  * Work around build failure with GCC 4.7, build with -fpermissive.
    Closes: #667379.

 -- Matthias Klose <doko@debian.org>  Thu, 10 May 2012 20:41:35 +0200

spring (88.0+dfsg1-1) unstable; urgency=low

  [ Jan Dittberner ]
  * New upstream version.
  * remove include/GL and include/SDL when repacking upstream tarball
  * debian/rules: remove unneeded repacking from get-orig-source target.
    Repacking is done in debian/new-upstream that is called by uscan
  * refresh debian/patches/0005-fix-sdl-build.patch
  * update Standards-Version to 3.9.3 (no changes)
  * update debian/copyright to 1.0 format

  [ Marco Amadori ]
  * Refreshed boost fix patch.
  * Include python unitsync bindings.

 -- Jan Dittberner <jandd@debian.org>  Sat, 31 Mar 2012 13:07:36 +0200

spring (85.0+dfsg1-3) unstable; urgency=low

  * Fixes compilation problems under boost 1.48 (Closes: #660450).
  * Parallel build the debhelper's way.
  * Removed plus signs in debian/rules.

 -- Marco Amadori <marco.amadori@gmail.com>  Mon, 27 Feb 2012 23:05:00 +0100
