=== debian/watch ===
version=3
opts=dversionmangle=s/\+dfsg\d+$// \
 http://sf.net/springrts/spring_([\d\.]+)_src\.tar\.gz debian debian/new-upstream
